#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ELEMENTOS_MAX 3

struct elemento_t{
    char abv[2];
    float masa_atomica;
    char nombre[10];
};

struct elemento_t * crear_tabla_periodica(int size);
struct elemento_t crear_elemento(char * abv, char * nombre, float masa);
struct elemento_t bus_elemento_abv(char * abv, struct elemento_t * tabla, int sz_tabla);

int main(int argc, char *argv[])
{
    struct elemento_t * tabla_periodica = crear_tabla_periodica(ELEMENTOS_MAX);
    struct elemento_t mi_el_busc;
    
    /*
	 Leer desde el teclado la abreviatura y pasarle el dato a la funcion de busqueda
	*/
    
    
    mi_el_busc = bus_elemento_abv("N", tabla_periodica, ELEMENTOS_MAX);
    
    printf("-------------Elemento encontrado--------------\n");
    printf("Abreviatura: %s\nNombre: %s\nMasa atomica: %f\n",mi_el_busc.abv,mi_el_busc.nombre, mi_el_busc.masa_atomica);
	printf("----------------------------------------------\n");
    
	return 0;
}
//Crea una tabla periodica... No es mas que un array de elementos
struct elemento_t * crear_tabla_periodica(int size)
{
    struct elemento_t * tabla_periodica = (struct elemento_t *)malloc(size * sizeof(struct elemento_t));

    tabla_periodica[0] = crear_elemento("H", "Hidrogeno",  1.0079);
    tabla_periodica[1] = crear_elemento("Na", "Sodio",  22.9897);
    tabla_periodica[2] = crear_elemento("N", "Nitrogeno",  14.0067);
    

    return tabla_periodica;
}

//crea un elemento con sus datos basicos
struct elemento_t crear_elemento(char * abv, char * nombre, float masa)
{
    struct elemento_t el;
    
    memcpy(el.abv, abv, sizeof(el.abv));
    memcpy(el.nombre, nombre, sizeof(el.nombre));
    el.masa_atomica = masa;
    
    return el;
}

//busca un elementos dada su abrieviatura
struct elemento_t bus_elemento_abv(char * abv, struct elemento_t * tabla, int sz_tabla)
{
	struct elemento_t el_encontrado = crear_elemento("","",0.0); //Datos en blanco por si el elementos no es encontrado
	int i;
	
	for(i = 0; i < sz_tabla; i++)
	{	
		if(strcmp(tabla[i].abv, abv) == 0)
		{
			el_encontrado = tabla[i];
			break;
		}
	}


	return el_encontrado;
}
